﻿using MemoryUtil;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using WebApplicationTestDI.Business;

namespace ConsoleTestMemoryAllocation
{
    class Program
    {
        static void Main(string[] args)
        {
            #region 
            // FillMemoryWithDummyData
            //UserContext context = new UserContext();
            //context.Parents = new System.Collections.Generic.List<WebApplicationTestDI.Entity.Parent>();
            //for (int i = 0; i < 10000; i++)
            //{
            //    context.Parents.AddRange(new UserRepository().GetParents(1000));
            //}
            #endregion

            var spaceship = new Spaceship();

            Measure(() =>
            {
                for (int i = 1; i < 500000; i++)
                {
                    var users = spaceship.GetTravelers();
                }
            });

            Console.ReadLine();
        }

        private static GCCounter _gcCounter = new GCCounter();
        private static TimeSpan Measure(Action action)
        {
            _gcCounter.TakeSnapshot();
            var sw = Stopwatch.StartNew();

            action();

            sw.Stop();

            _gcCounter.TakeSnapshot();
            _gcCounter.PrintToConsole(sw.Elapsed.ToString(), false);

            return sw.Elapsed;
        }
    }
}
