﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleTestRuntime
{
    public class Spaceship : ISpaceship
    {
        private List<Traveler> _travelers;

        public Spaceship()
        {
            _travelers = new List<Traveler>();

            for (int i = 0; i < 5000; i++)
            {
                _travelers.Add(new Traveler()
                {
                    Id = i,
                    FirstName = "FirstName_" + i,
                    LastName = "LastNane_" + i,
                    Age = i
                });
            }
        }

        public List<Traveler> GetAdults()
        {
            var adults = _travelers.Where(p => p.Age > 4000).ToList();
            return adults;
        }

        public bool HasAdult()
        {
            var hasAdult = GetAdults().Count > 0;
            return hasAdult;
        }

        public bool HasTraveler(string name)
        {
            var hasAdult = _travelers.Any(p => p.FirstName.ToUpper() == name.ToUpper());
            return hasAdult;
        }
    }
}
