﻿using Castle.DynamicProxy;
using Microsoft.Extensions.Caching.Memory;
using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges.Castle
{
    public class CachingInterceptor : IInterceptor
    {
        IMemoryCache _cache;
        public CachingInterceptor(IMemoryCache cache)
        {
            _cache = cache;
        }
        public void Intercept(IInvocation invocation)
        {
            var key = $"{invocation.Method.ReflectedType.Name}.{invocation.Method.Name}";

            var result = _cache.GetOrCreate<object>(key, (cacheEntry) =>
            {
                invocation.Proceed();
                return invocation.ReturnValue;
            });

            if (invocation.ReturnValue == null)
                invocation.ReturnValue = result;
        }
    }
}
