﻿using Castle.Core;
using Castle.MicroKernel;
using Castle.MicroKernel.Registration;
using Castle.Windsor.MsDependencyInjection;
using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges.Castle
{
    public class RegisterInterceptors : IRegistration
    {
        public void Register(IKernelInternal kernel)
        {
            kernel.Register(Component.For<StopwatchInterceptor>().ImplementedBy<StopwatchInterceptor>().LifestyleTransient());
            kernel.Register(Component.For<CachingInterceptor>().ImplementedBy<CachingInterceptor>().LifestyleTransient());


            foreach (var handler in kernel.GetAssignableHandlers(typeof(object)))
            {
                if (handler.ComponentModel.Name.Contains("ISpaceship"))
                {
                    handler
                        .ComponentModel
                        .Interceptors
                        .Add(new InterceptorReference(typeof(StopwatchInterceptor)));

                    handler
                    .ComponentModel
                    .Interceptors
                    .Add(new InterceptorReference(typeof(CachingInterceptor)));
                }
            }
        }
    }
}
