﻿using Castle.DynamicProxy;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleTestRuntimeArchitectureChanges.Castle
{
    public class StopwatchInterceptor : IInterceptor
    {
        public void Intercept(IInvocation invocation)
        {
            try
            {
                var sw = new Stopwatch();
                sw.Start();

                invocation.Proceed();
                
                sw.Stop();
                Console.WriteLine($"{invocation.Method.ReflectedType.Name}.{invocation.Method.Name}:\t{sw.Elapsed}");
            }
            catch (Exception)
            {
                throw;
            }
        }
    }
}
