﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges
{
    public class Spaceship : ISpaceship
    {
        private List<Traveler> _traveler;

        public Spaceship()
        {
            #region init
            _traveler = new List<Traveler>();

            for (int i = 0; i < 5000; i++)
            {
                _traveler.Add(new Traveler()
                {
                    Id = i,
                    FirstName = "FirstName_" + i,
                    LastName = "LastNane_" + i,
                    Age = i
                });
            }
            #endregion
        }

        #region

        public List<Traveler> GetAdults()
        {
            var adults = _traveler.Where(p => p.Age > 4000).ToList();
            return adults;
        }

        public bool HasAdult()
        {
            var hasAdult = GetAdults().Count > 0;
            return hasAdult;
        }
        #endregion

        public bool HasTraveler(string name)
        {
            var hasAdult = _traveler.Any(p => p.FirstName.ToUpper() == name.ToUpper());
            return hasAdult;
        }
    }
}
