﻿using Microsoft.Extensions.Caching.Memory;
using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges.Improved
{
    public class SpaceshipCachig : ISpaceship
    {
        ISpaceship _spaceship;
        IMemoryCache _cache;
        public SpaceshipCachig(ISpaceship spaceship, IMemoryCache cache)
        {
            _spaceship = spaceship;
            _cache = cache;
        }

        #region
        public List<Traveler> GetAdults()
        {
             var adults = _cache.GetOrCreate<List<Traveler>>("GetAdults", (cacheEntry) =>
             {
                 return _spaceship.GetAdults();
             });

            return adults;
        }

        public bool HasAdult()
        {
            var hasAdult = _cache.GetOrCreate<bool>("HasAdult", (cacheEntry) =>
            {
                return _spaceship.HasAdult(); ;
            });

            return hasAdult;
        }
        #endregion

        public bool HasTraveler(string name)
        {
            var hasTraveler = _cache.GetOrCreate<bool>("HasTraveler", (cacheEntry) =>
            {
                return _spaceship.HasTraveler(name); ;
            });

            return hasTraveler;
        }
    }
}
