﻿using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges.Improved
{
    public class SpaceshipLogging : ISpaceship
    {
        ISpaceship _spaceship;
        ILogger<Spaceship> _logger;
        ITravelerValidation _validation;
        public SpaceshipLogging(ISpaceship spaceship, ILogger<Spaceship> logger, ITravelerValidation travelerValidation)
        {
            _spaceship = spaceship;
            _logger = logger;
            _validation = travelerValidation;
        }
        #region
        public List<Traveler> GetAdults()
        {
            var adults =_spaceship.GetAdults();
            _logger.LogInformation($"Adults.Count: {adults.Count}");
            return adults;
        }

        public bool HasAdult()
        {
            var hasAdult = _spaceship.HasAdult();
            _logger.LogInformation($"HasAdult: {hasAdult}");

            return hasAdult;
        }
        #endregion

        public bool HasTraveler(string name)
        {
            if (!_validation.IsValidName(name))
            {
                _logger.LogInformation($"invalid name: {name}");
            }

            var hasTraveler = _spaceship.HasTraveler(name);

            _logger.LogInformation($"hasTraveler: {hasTraveler}");

            return hasTraveler;
        }
    }
}
