﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.CompilerServices;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges.Improved
{
    public class SpaceshipProfiling : ISpaceship
    {
        ISpaceship _spaceship;
        public SpaceshipProfiling(ISpaceship spaceship)
        {
            _spaceship = spaceship;
        }
        #region
        public List<Traveler> GetAdults()
        {
            var adults = Measure(() =>
            {
                return _spaceship.GetAdults();
            });

            return adults;
        }

        public bool HasAdult()
        {
            var hasAdult = Measure(() =>
            {
                return _spaceship.HasAdult();
            });

            return hasAdult;
        }
        #endregion
        public bool HasTraveler(string name)
        {
            var hasUser = Measure(() =>
            {
                return _spaceship.HasTraveler(name);
            });

            return hasUser;
        }

        private T Measure<T>(Func<T> func, [CallerMemberName] string memberName = "")
        {
            var sw = new Stopwatch();
            sw.Start();
            var result = func();
            sw.Stop();
            Console.WriteLine($"{memberName}:\t{sw.Elapsed}");

            return result;
        }
    }
}
