﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleTestRuntimeArchitectureChanges.Improved
{
    public class SpaceshipValidation : ISpaceship
    {
        private ISpaceship _spaceship;
        private ITravelerValidation _validation;
        public SpaceshipValidation(ISpaceship spaceship,ITravelerValidation travelerValidation)
        {
            _spaceship = spaceship;
            _validation = travelerValidation;
        }
        #region 
        public List<Traveler> GetAdults()
        {
            return _spaceship.GetAdults();
        }

        public bool HasAdult()
        {
            return _spaceship.HasAdult();
        }
        #endregion

        public bool HasTraveler(string name)
        {
            if (!_validation.IsValidName(name))
            {
                throw new ArgumentException("Invalid name");
            }

            return _spaceship.HasTraveler(name);
        }
    }
}
