﻿using System;
using System.Collections.Generic;
using System.Text;

namespace MemoryUtil
{
    public class GCCounter
    {
        private int _snapshotCounter;
        public int ZeroCollectionCount { get; set; }
        public int OneCollectionCount { get; set; }
        public int TwoCollectionCount { get; set; }

        public int ZeroCollectionDiff { get; set; }
        public int OneCollectionDiff { get; set; }
        public int TwoCollectinDiff { get; set; }

        private void AddGenZero(int count)
        {
            ZeroCollectionDiff = count - ZeroCollectionCount;
            ZeroCollectionCount = count;
        }
        private void AddGenOne(int count)
        {
            OneCollectionDiff = count - OneCollectionCount;
            OneCollectionCount = count;
        }
        private void AddGenTwo(int count)
        {
            TwoCollectinDiff = count - TwoCollectionCount;
            TwoCollectionCount = count;
        }

        public void TakeSnapshot()
        {
            var zero = GC.CollectionCount(0);
            var one = GC.CollectionCount(1);
            var two = GC.CollectionCount(2);

            AddGenZero(zero);
            AddGenOne(one);
            AddGenTwo(two);

            _snapshotCounter++;
        }

        public void PrintToConsole(string text = "", bool showTotal = true)
        {
            Console.WriteLine($"Diff\tsnapshots:{_snapshotCounter}\tGen0:{ZeroCollectionDiff} Gen1:{OneCollectionDiff} Gen2:{TwoCollectinDiff}\t{text}");
            if (showTotal)
                Console.WriteLine($"Total\tsnapshots:{_snapshotCounter}\tGen0:{ZeroCollectionCount} Gen1:{OneCollectionCount} Gen2:{TwoCollectionCount}\t{text}");
        }
    }
}
